/*
 *  FILE    : MainPanel.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import com.ibm.xml.parsers.DOMParser;

public class MainPanel extends JPanel {
    // ctor
    public MainPanel(MajordomoUser _parent) {
        parent = _parent;

        // subscribe button
        subscribeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cName = (String)table.getValueAt(table.getSelectedRow(),0);
                
                try {
                    uEmail = parent.dm.getValue("user", parent._userName, "e-mail"); 
                    emailList = parent.dm.getValue("community", cName, "userlist");
                    checkMember = member(uEmail, emailList, cName);
                }
                catch(IOException e1) {}
                catch(SAXException e2) {}
                
                if(checkMember) {
                    JOptionPane.showMessageDialog( parent.frame, "You are already member of Community!!"
                            , "Subscribe Error", JOptionPane.WARNING_MESSAGE );
                }
                else {
		    // send Email to Majordomo to subscribe
                    setUpMail();            
                    tm.setContext("subscribe " + cName + " " + uEmail);
                    try {
                        tm.sendMail();
                    }
                    catch(MailException me) {}
                      
                    String nEmailList = parent.dm.getValue("community", cName, "userlist") + "<email>" + parent.dm.getValue("user", parent._userName, "e-mail") + "</email>";
                    String nCommList = parent.dm.getValue("user", parent._userName, "community") + "<community>" + cName + "</community>";
                    
		    // update User information to User Data
                    try{
                        parent.dm.setValue("community", cName, "userlist", nEmailList);
                        parent.dm.setValue("user", parent._userName, "community", nCommList); 
                        parent.dm.update();
                    }
                    catch(Exception eee) {}
                    
                    JOptionPane.showMessageDialog( parent.frame, "Subscription is requested!!"
                            , "Subscription Request", JOptionPane.INFORMATION_MESSAGE );
                    table.setValueAt(Boolean.TRUE, table.getSelectedRow(), 1);
                }
            }
        });
        
        // unsubscribe button
        unsubscribeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cName = (String)table.getValueAt(table.getSelectedRow(),0);
                try {
                    uEmail = parent.dm.getValue("user", parent._userName, "e-mail"); 
                    emailList = parent.dm.getValue("community", cName, "userlist");
                    checkMember = member(uEmail, emailList, cName);
                }
                catch(IOException e1) {}
                catch(SAXException e2) {}
                
                if(checkMember) {
		    // send Email to Majordomo to subscribe
                    setUpMail();            
                    tm.setContext("unsubscribe " + cName + " " + uEmail);
                    String nEmailList = null;
                    String nCommList = null;
                    String commList = parent.dm.getValue("user", parent._userName, "community");
                    
                    try {
                        tm.sendMail();
                    }
                    catch(MailException me) {}
                    
                    try {
                        nEmailList = emailList.substring(0, emailList.indexOf("<email>" + uEmail + "</email>")) 
                                    + emailList.substring(15 + emailList.indexOf("<email>" + uEmail + "</email>") + uEmail.length());
                    
                        nCommList =  commList.substring(0, commList.indexOf("<community>" + cName + "</community>"))
                                    + commList.substring(23 + commList.indexOf("<community>" + cName + "</community>") + uEmail.length());
                    }
                    catch(StringIndexOutOfBoundsException sobe) {}
                    
		    // update User information to User Data
                    try{
                        parent.dm.setValue("community", cName, "userlist", nEmailList);
                        parent.dm.update();
                    }
                    catch(Exception eee) {}
                    
                    JOptionPane.showMessageDialog( parent.frame, "UnSubscription is requested!!"
                            , "UnSubscription Request", JOptionPane.INFORMATION_MESSAGE );
                    table.setValueAt(Boolean.FALSE, table.getSelectedRow(), 1);
                }
                else {
                    JOptionPane.showMessageDialog( parent.frame, "You are not the member of Community!!"
                            , "UnSubscribe Error", JOptionPane.WARNING_MESSAGE );
                }
            }
        });
        
        // table
        // definition of table header         
        Vector columnNames = new Vector();            
        columnNames.addElement("Majordomo List");
        columnNames.addElement("Subscribed/Unsubscribed");
        table = new JTable(model = new CommunityTableModel(data, columnNames));        
        
        // scroll pane
        JScrollPane sp = new JScrollPane(table);
        JPanel tablePanel = new JPanel(new BorderLayout());
        tablePanel.setBorder(new EmptyBorder(5, 5, 0, 5)); 
        tablePanel.add(sp, BorderLayout.CENTER);
        
        // button panel
        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        buttonPanel.add(subscribeButton);
        buttonPanel.add(unsubscribeButton);
        
        // gui
        setLayout(new BorderLayout());
        add(tablePanel, BorderLayout.CENTER);
        add(buttonPanel, BorderLayout.SOUTH);
    }

  // set-up parameters for TangoMail 
    public void setUpMail() {
        try {
            StringTokenizer st = new StringTokenizer(parent.dm.getValue("community", cName, "e-mail"), "@");
            st.nextToken();
            tm = new TangoMail(st.nextToken());
            System.out.println("TM established");
            v = new Vector();
            tm.setSubject("");
            tm.setFrom(parent._userName, parent.dm.getValue("user", parent._userName, "e-mail"));
            v.removeAllElements();
            h.put("toname", cName);
            h.put("toadr", parent.dm.getValue("community", cName, "e-mail"));
            v.addElement(h);
            tm.addTo(v);
        }
        catch(Exception e1) {}
    }
  
    // check whether user is the member of community or not 
    public boolean member(String uEmail, String emailList, String cName) throws IOException, SAXException{
        DOMParser parser = new DOMParser();
        StringBufferInputStream sbis= new StringBufferInputStream("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?><doc>" + emailList + "</doc>");
        InputSource is = new InputSource(sbis);
        parser.parse(is);
        Document doc = parser.getDocument();
        Element root = doc.getDocumentElement();
        NodeList objects = root.getElementsByTagName("email");
        for (int i = 0; i < objects.getLength(); i++) {
            String ObjName = objects.item(i).getFirstChild().getNodeValue();
            if(ObjName.compareTo(uEmail)==0) { return true; }
        }
        return false; 
    }
    
    public void addCommunity(Community community) {
        model.addRow(community);
    }
    
    public void removeCommunityAt(int index) {
        model.removeRow(index);
    }
    
    
    protected MajordomoUser parent;  
    protected Vector data = new Vector();
    protected JTable table;
    protected JButton subscribeButton = new JButton("Subscribe");
    protected JButton unsubscribeButton = new JButton("Unsubscribe");    
    protected CommunityTableModel model;
    
    protected TangoMail tm;
    protected String cName, uEmail, emailList;
    protected boolean checkMember = true;
    protected InputStream byteStream;
    protected Vector v; 
    protected Hashtable h = new Hashtable();
}

