/*
 *  FILE    : ChangePasswordPanel.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

public class ChangePasswordPanel extends JPanel {
    public ChangePasswordPanel(MainPanel _mp) {
        mp = _mp;
        
        // clear button
        clearButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setDefault();
            }
        });
        
        // change button
        changeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                // get parameters from Data module
                communityName = mp.parent.comMaster;
                communityAddress = mp.parent.dm.getValue("community", mp.parent.comMaster, "e-mail");
                adminEmail = mp.parent.dm.getValue("user", mp.parent._userName, "e-mail");
                
                // get password
                String oldPasswd = oldPw.getText();
                String newPasswd = newPw.getText();
                String retypedPasswd = retypedPw.getText();
                
                if((oldPasswd.compareTo("")==0)||(newPasswd.compareTo("")==0)) {
                    JOptionPane.showMessageDialog( mp.parent.frame, "Please fill out all field!", "Field Missing", JOptionPane.ERROR_MESSAGE );    
                }
                else {
                    pDialog = new PasswdDialog(mp.parent);
                    pDialog.setVisible(true);
                
                    // password change
                    if(pDialog.getValid()) {
                        if(retypedPasswd.compareTo("")!=0) {
                            String passWd = pDialog.getPasswd();
                            if((retypedPasswd.compareTo(newPasswd)==0) && (passWd.compareTo(oldPasswd)==0)) {
                                setUpMail();            
                                pDialog.dispose();
                                try {
                                    tm.setContext(passWd + " " + mp.parent.comMaster + " " + oldPasswd + " " +newPasswd);
                                    tm.sendMail();
                                    JOptionPane.showMessageDialog( mp.parent.frame, "Password is changed!", "Password", JOptionPane.INFORMATION_MESSAGE );    
                                    setDefault();
                                    try {
                                        mp.parent.dm.setValue("community", mp.parent.comMaster, "password", mp.parent.pm.getEncPasswd(newPasswd));
                                    }
                                    catch(Exception se) {}
                                }
                                catch(MailException me) {}
                            }
                            else {
                                JOptionPane.showMessageDialog( mp.parent.frame, "Password is not matched!", "Invalid Password", JOptionPane.ERROR_MESSAGE );
                            }
                        }    
                        else {
                            JOptionPane.showMessageDialog( mp.parent.frame, "Please Re-Type Password!", "Password Missing", JOptionPane.ERROR_MESSAGE );
                        }
                    }
                    else {}
                }
            }
        });
        
        // input panel
		gbConstraints.fill = GridBagConstraints.NONE;
		gbConstraints.anchor = GridBagConstraints.WEST;         
        JPanel inputPanel = new JPanel(gbLayout);
        inputPanel.setBorder(new CompoundBorder(
            new EmptyBorder(5, 5, 0, 5), new EtchedBorder()));
    	addComponent(inputPanel, new JLabel("Old:"), 0, 0, 1, 1, new Insets(5, 5, 2, 2));
    	addComponent(inputPanel, new JLabel("New:"), 1, 0, 1, 1, new Insets(0, 5, 2, 2));
        addComponent(inputPanel, new JLabel("Retype:"), 2, 0, 1, 1, new Insets(0, 5, 2, 2));
    	addComponent(inputPanel, oldPw, 0, 1, 1, 1, new Insets(5, 0, 2, 5));
    	addComponent(inputPanel, newPw, 1, 1, 1, 1, new Insets(0, 0, 2, 5));
        addComponent(inputPanel, retypedPw, 2, 1, 1, 1, new Insets(0, 0, 2, 5));    	                  
        
        // button panel
        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        buttonPanel.add(clearButton);
        buttonPanel.add(changeButton);
                
        // gui
        setLayout(new BorderLayout());
        add(inputPanel, BorderLayout.CENTER);
        add(buttonPanel, BorderLayout.SOUTH);
    }
    
    // addComponent:
    // adds components to container according to grid
    // constraints parameters
    public void addComponent(JPanel p, JComponent c, int row, int column,
     	                     int width, int height, Insets insets) {
	     // set gridx and gridy
	     gbConstraints.gridx = column;
         gbConstraints.gridy = row;
         // set gridwidth and gridheight
	     gbConstraints.gridwidth = width;
         gbConstraints.gridheight = height;
         gbConstraints.insets = insets; 
	     // set constraints
	     gbLayout.setConstraints(c, gbConstraints);         
	     // add component
         p.add(c);
	}

    // set up mail parameters
    public void setUpMail() {
        try {
            StringTokenizer st = new StringTokenizer(communityAddress, "@");
            st.nextToken();
            tm = new TangoMail(st.nextToken());
            System.out.println("TM established");
            tm.setSubject("");
            tm.setFrom("", adminEmail);
            v.removeAllElements();
            h.put("toname", communityName);
            h.put("toadr", communityAddress);
            v.addElement(h);
            tm.addTo(v);
        }
        catch(Exception e1) {}
    }
    
    // set panel as default
    public void setDefault() {
        newPw.setText("");
        oldPw.setText("");
        retypedPw.setText("");
    }
    
	private GridBagConstraints gbConstraints = new GridBagConstraints();
	private GridBagLayout gbLayout = new GridBagLayout();   	
    protected MainPanel parent;        
    protected JPasswordField oldPw = new JPasswordField(15);
    protected JPasswordField newPw = new JPasswordField(15);
    protected JPasswordField retypedPw = new JPasswordField(15);
    protected JButton clearButton = new JButton("Clear All");
    protected JButton changeButton = new JButton("Change");
    
    protected Vector v = new Vector(); 
    protected Hashtable h = new Hashtable();
    protected String communityAddress;
    protected String communityName;
    protected String adminEmail;
    protected String passWd;
    protected boolean modal;
    
    protected MainPanel mp;
    protected TangoMail tm;        
    protected PasswdDialog pDialog;
}
