/*
 *  FILE    : LoginPanel.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import webwisdom.tango.config.*;

public class LoginPanel extends JPanel {

    // ctor
    public LoginPanel(MajordomoAdm _parent) {
        parent = _parent;

        // login button
        loginButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
         
                // get parameters
                parent._userName = username.getText();
                parent._passWord = password.getText();
                String validPass = parent.dm.getValue("user", parent._userName, "password");
                String newEncPasswd = PasswdManager.getEncPasswd(parent._passWord);
                
                // checking user information from Data module
                Enumeration eUser = parent.dm.getObjects("user");
                while( eUser.hasMoreElements() ) {
                    validUser = eUser.nextElement().toString().equals(parent._userName);
                    if(validUser) break;
                }
                
                try {
                    parent.comMaster = parent.dm.getValue("user", parent._userName, "role");
                }
                catch(Exception ee) {}
                
                Enumeration eComm = parent.dm.getObjects("community");
                while( eComm.hasMoreElements() ) {
                    validComm = eComm.nextElement().toString().equals(parent.comMaster);
                    if(validComm) break;
                }
                
                // user validation 
                if( validUser ) {
                    if( validPass != null && validPass.equals(newEncPasswd) ) {
                        if( (parent.comMaster.compareTo("default")!= 0 ) && validComm ) {
                            parent.showMainPanel();
                            parent.frame.setTitle(parent.comMaster);
                        }
                        else {
                            JOptionPane.showMessageDialog( parent.frame, "You don't have privilege to use this tool", "Access Denied", JOptionPane.ERROR_MESSAGE );
                        }    
                    }
                    else {
                        JOptionPane.showMessageDialog( parent.frame, "PassWord is not matched!!", "PassWord Error", JOptionPane.ERROR_MESSAGE );
                    }
                }
                else {
                    JOptionPane.showMessageDialog( parent.frame, "Can't Find User Name!!", "User Name Error", JOptionPane.ERROR_MESSAGE );
                }
            }
        });
        
        // input panel
		gbConstraints.fill = GridBagConstraints.NONE;
		gbConstraints.anchor = GridBagConstraints.WEST;         
        JPanel inputPanel = new JPanel(gbLayout);
        inputPanel.setBorder(new CompoundBorder(
            new EmptyBorder(0, 5, 5, 5), new EtchedBorder()));        
    	addComponent(inputPanel, new JLabel("User name:"), 0, 0, 1, 1, new Insets(5, 5, 2, 2));
    	addComponent(inputPanel, new JLabel("Password:"), 1, 0, 1, 1, new Insets(0, 5, 2, 2));
    	addComponent(inputPanel, username, 0, 1, 1, 1, new Insets(5, 0, 2, 5));
    	addComponent(inputPanel, password, 1, 1, 1, 1, new Insets(0, 0, 2, 5));
    	gbConstraints.anchor = GridBagConstraints.CENTER;  
    	addComponent(inputPanel, loginButton, 2, 0, 2, 1, new Insets(20, 5, 5, 5));

        
        // header panel
        JPanel headerPanel = new JPanel();
        headerPanel.setBorder(new CompoundBorder(
            new EmptyBorder(5, 5, 2, 5), new EtchedBorder()));
        headerPanel.add(new JLabel("TangoDomo Admin Tool"));
            
        // gui
        setLayout(new BorderLayout());
        add(headerPanel, BorderLayout.NORTH);
        add(inputPanel, BorderLayout.CENTER);        
    }

    // addComponent:
    // adds components to container according to grid
    // constraints parameters
    public void addComponent(JPanel p, JComponent c, int row, int column,
     	                     int width, int height, Insets insets) {
	     // set gridx and gridy
	     gbConstraints.gridx = column;
         gbConstraints.gridy = row;
         // set gridwidth and gridheight
	     gbConstraints.gridwidth = width;
         gbConstraints.gridheight = height;
         gbConstraints.insets = insets; 
	     // set constraints
	     gbLayout.setConstraints(c, gbConstraints);         
	     // add component
         p.add(c);
	}

    private GridBagConstraints gbConstraints = new GridBagConstraints();
    private GridBagLayout gbLayout = new GridBagLayout();   	
    protected MajordomoAdm parent;        
    protected JTextField username = new JTextField(12);
    protected JPasswordField password = new JPasswordField(12);
    protected JButton loginButton = new JButton("Login");

    protected boolean validUser = false;
    protected boolean validComm = false;
}    

