/*
 *  FILE    : MajordomoAdm.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.*;
import webwisdom.tango.config.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import com.ibm.xml.parsers.DOMParser;

public class MajordomoAdm {

    //ctor
    public MajordomoAdm() throws IOException {
        
        // instantiate dataModule and PasswdManager
        dm = new dataModule();

        // get file name using JFileChooser
        fileName = getFileName();
        
        if( fileName==null ) {
            JOptionPane.showMessageDialog( frame, "Please choose User Data File", 
            "File Name Error", JOptionPane.ERROR_MESSAGE );
            System.exit(1);
        }

        // get information from User file
        try {
            dm.open("file", fileName, "master", "master");
            System.out.println("File Opened");
        }
        catch(Exception e) {
            System.out.println(e.toString());
        }
        pm = new PasswdManager();
        
        // get frame
        frame = new JFrame("MajorDomo Admin Tool");
        
        frame.addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent e ) {
			    System.exit( 0 );
			}
			public void windowOpened(WindowEvent e) {}
            public void windowClosed(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowActivated(WindowEvent e) {}
            public void windowDeactivated(WindowEvent e) {}
		});
		
        // gui
        loginPanel = new LoginPanel(this);
        frame.getContentPane().setLayout(new BorderLayout());
        frame.getContentPane().add(loginPanel, BorderLayout.CENTER);   
        
        // ready 
        frame.setVisible(true);
        frame.pack();
    }
    
    // get File name using JFileChooser class
    public String getFileName() {
        String nfileName = null;
        JFileChooser chooser = new JFileChooser();
		chooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
		
		if( lastDir != null ) {
			chooser.setCurrentDirectory( lastDir );
		}
		int result = chooser.showOpenDialog( frame );
		if( result == JFileChooser.APPROVE_OPTION ) {
			// store current directory for future use
			lastDir = chooser.getCurrentDirectory();
			nfileName = chooser.getSelectedFile().getPath();
		}
		return nfileName;
	}
	
    // show main panel
    public void showMainPanel() {
        
        MainPanel mainPanel = new MainPanel(this);
        
        frame.getContentPane().removeAll();
        frame.getContentPane().add(mainPanel, BorderLayout.CENTER);
        frame.setSize(350, 230);
        frame.pack();
        frame.validate();
    }
    
    // main() of application
    public static void main(String[] args) {
        try {
            MajordomoAdm ma;
            ma = new MajordomoAdm();

        }
        catch(Exception e) {
            System.err.println("Can not create MajordomoAdm class. " +e.getMessage());
        }
        
    }
    
    protected JFrame frame;
    
    protected LoginPanel loginPanel;
    protected MainPanel mainPanel;    
    
    protected dataModule dm;
    protected PasswdManager pm;    
    protected String _userName = "default";
    protected String _passWord = "default"; 
    protected String comMaster = "default";
    protected File lastDir = null;
    protected String fileName = null;
}
